Index: /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zpoc.F90
===================================================================
--- /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zpoc.F90	(revision 6453)
+++ /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zpoc.F90	(revision 6453)
@@ -0,0 +1,431 @@
+MODULE p5zpoc
+   !!======================================================================
+   !!                         ***  MODULE p5zpoc  ***
+   !! TOP :   PISCES Compute remineralization of organic particles
+   !!=========================================================================
+   !! History :   1.0  !  2004     (O. Aumont) Original code
+   !!             2.0  !  2007-12  (C. Ethe, G. Madec)  F90
+   !!             3.4  !  2011-06  (O. Aumont, C. Ethe) Quota model for iron
+   !!             3.6  !  2015-05  (O. Aumont) PISCES quota
+   !!             3.6  !  2016-03  (O. Aumont) PISCES Quota and reorganization
+   !!----------------------------------------------------------------------
+#if defined key_pisces_quota
+   !!----------------------------------------------------------------------
+   !!   'key_top'       and                                      TOP models
+   !!   'key_pisces_quota'     PISCES bio-model with variable stoichiometry
+   !!----------------------------------------------------------------------
+   !!   p5z_poc       :  Compute remineralization of organic particles
+   !!   p5z_poc_init  :  Initialisation of parameters for remineralisation
+   !!   p5z_poc_alloc :  Allocate remineralisation variables
+   !!----------------------------------------------------------------------
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
+   USE p5zsink         !  Sedimentation of organic particles
+   USE prtctl_trc      !  print control for debugging
+   USE iom             !  I/O manager
+
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   p5z_poc         ! called in p4zbio.F90
+   PUBLIC   p5z_poc_init    ! called in trcsms_pisces.F90
+
+   !! * Shared module variables
+   REAL(wp), PUBLIC ::  xremipc    !: remineralisation rate of DOC
+   REAL(wp), PUBLIC ::  xremipn    !: remineralisation rate of DON
+   REAL(wp), PUBLIC ::  xremipp    !: remineralisation rate of DOP
+   INTEGER , PUBLIC ::  jcpoc      !: number of lability classes
+
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)     ::   alphan, reminp
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) :: alphap
+
+   !!* Substitution
+#  include "top_substitute.h90"
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Id: p4zrem.F90 3160 2011-11-20 14:27:18Z cetlod $ 
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE p5z_poc( kt, knt )
+      !!---------------------------------------------------------------------
+      !!                     ***  ROUTINE p5z_poc  ***
+      !!
+      !! ** Purpose :   Compute remineralization of organic particles
+      !!
+      !! ** Method  : - ???
+      !!---------------------------------------------------------------------
+      !
+      INTEGER, INTENT(in) ::   kt, knt ! ocean time step
+      !
+      INTEGER  ::   ji, jj, jk, jn
+      REAL(wp) ::   zremip, zremig, zdep, ztem, zstep
+      REAL(wp) ::   zopon, zopop, zopoc2, zopon2, zopop2, zofer
+      REAL(wp) ::   zsizek, zsizek1, alphat, remint
+      REAL(wp) ::   solgoc, zpoc, zpoctot, zremif
+#if ! defined key_kriest
+      REAL(wp) ::   zofer2, zofer3
+#endif
+      REAL(wp) ::   step, zrfact2
+      CHARACTER (len=25) :: charout
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: zwork1
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: totprod, totthick, totcons
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: zremipoc, zremigoc, zorem3
+      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: alphag
+      !!---------------------------------------------------------------------
+      !
+      IF( nn_timing == 1 )  CALL timing_start('p5z_poc')
+      !
+      ! Allocate temporary workspace
+      CALL wrk_alloc( jpi, jpj, jpk, zwork1 )
+      CALL wrk_alloc( jpi, jpj,      totprod, totthick, totcons )
+      CALL wrk_alloc( jpi, jpj, jpk, zremipoc, zremigoc, zorem3 )
+      ALLOCATE( alphag(jpi,jpj,jpk,jcpoc) )
+
+      ! Here we compute the GOC -> POC rate due to the shrinking
+      ! of the fecal pellets/aggregates as a result of bacterial
+      ! solubilization
+      ! This is based on a fractal dimension of 2.56 and a spectral
+      ! slope of -3.6 (identical to what is used in p4zsink to compute
+      ! aggregation
+      solgoc = 0.04/ 2.56 * 1./ ( 1.-50**(-0.04) )
+
+      ! Initialisation of temprary arrys
+      zremipoc(:,:,:) = xremipc
+      zremigoc(:,:,:) = xremipc
+      zorem3(:,:,:)   = 0.
+      orem  (:,:,:)   = 0.
+
+      DO jn = 1, jcpoc
+        alphag(:,:,:,jn) = alphan(jn)
+      END DO
+
+#if ! defined key_kriest
+     DO jk = 2, jpkm1
+        DO jj = 1, jpj
+           DO ji = 1, jpi
+              IF (tmask(ji,jj,jk) == 1.) THEN
+                zdep = hmld(ji,jj)
+                IF( fsdept(ji,jj,jk) >= zdep ) THEN
+                  alphat = 0.
+                  remint = 0.
+                  IF ( fsdept(ji,jj,jk-1) < zdep ) THEN
+                    DO jn = 1, jcpoc
+                       zsizek  = zdep / (wsbio2 + rtrn) * tgfunc(ji,jj,jk-1)
+                       zsizek1 = fse3t(ji,jj,jk) / 2. / (wsbio4(ji,jj,jk) + rtrn) * tgfunc(ji,jj,jk)
+                       zpoc = trb(ji,jj,jk-1,jpgoc) + consgoc(ji,jj,jk) * rday / rfact2               &
+                       &   * fse3t(ji,jj,jk) / 2. / (wsbio4(ji,jj,jk) + rtrn)
+                       zpoc = max(0., zpoc)
+                       alphag(ji,jj,jk,jn) = alphan(jn) / (reminp(jn) * tgfunc(ji,jj,jk-1) )       &
+                       &   * (1. - exp( -reminp(jn) * zsizek ) ) * exp( -reminp(jn) * zsizek1 )     &
+                       &   * zpoc + prodgoc(ji,jj,jk) * ( 1. - exp( -reminp(jn) * zsizek1 ) )        &
+                       &   * rday / rfact2 * alphan(jn) / reminp(jn) / tgfunc(ji,jj,jk)
+                       alphat = alphat + alphag(ji,jj,jk,jn)
+                       remint = remint + alphag(ji,jj,jk,jn) * reminp(jn)
+                    END DO
+                  ELSE
+                    DO jn = 1, jcpoc
+                       zsizek  = fse3t(ji,jj,jk-1) / 2. / (wsbio4(ji,jj,jk-1) + rtrn) * tgfunc(ji,jj,jk-1)
+                       zsizek1 = fse3t(ji,jj,jk) / 2. / (wsbio4(ji,jj,jk) + rtrn) * tgfunc(ji,jj,jk)
+                       zpoc = trb(ji,jj,jk-1,jpgoc) + consgoc(ji,jj,jk-1) * rday / rfact2               &
+                       &   * fse3t(ji,jj,jk-1) / 2. / (wsbio4(ji,jj,jk-1) + rtrn) + consgoc(ji,jj,jk)   &
+                       &   * rday / rfact2 * fse3t(ji,jj,jk) / 2. / (wsbio4(ji,jj,jk) + rtrn)
+                       zpoc = max(0., zpoc)
+                       alphag(ji,jj,jk,jn) = alphag(ji,jj,jk-1,jn) * exp( -reminp(jn)                &
+                       &   * ( zsizek + zsizek1 ) ) * zpoc + ( prodgoc(ji,jj,jk-1)  &
+                       &   / tgfunc(ji,jj,jk-1) * ( 1. - exp( -reminp(jn) * zsizek ) )                 &
+                       &   * exp( -reminp(jn) * zsizek1 ) + prodgoc(ji,jj,jk) / tgfunc(ji,jj,jk)       &
+                       &   * ( 1. - exp( -reminp(jn) * zsizek1 ) ) ) * rday / rfact2 * alphan(jn)     &
+                       &   / reminp(jn)
+                       alphat = alphat + alphag(ji,jj,jk,jn)
+                       remint = remint + alphag(ji,jj,jk,jn) * reminp(jn)
+                    END DO
+                  ENDIF
+                  DO jn = 1, jcpoc
+                     alphag(ji,jj,jk,jn) = alphag(ji,jj,jk,jn) / ( alphat + rtrn)
+                  END DO
+                  zremigoc(ji,jj,jk) = MIN(xremipc, MAX(0., remint / ( alphat + rtrn) ))
+                ENDIF
+              ENDIF
+            END DO
+         END DO
+      END DO
+
+      DO jk = 1, jpkm1
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zstep   = xstep
+# if defined key_degrad
+               zstep = zstep * facvol(ji,jj,jk)
+# endif
+               ! POC disaggregation by turbulence and bacterial activity. 
+               ! --------------------------------------------------------
+               zremig = zremigoc(ji,jj,jk) * zstep * tgfunc(ji,jj,jk)
+               zopoc2 = zremig  * trb(ji,jj,jk,jpgoc)
+               zopon2 = xremipn / xremipc * zremig * trb(ji,jj,jk,jpgon)
+               zopop2 = xremipp / xremipc * zremig * trb(ji,jj,jk,jpgop)
+               zofer2 = xremipn / xremipc * zremig * trb(ji,jj,jk,jpbfe)
+               zorem3(ji,jj,jk) = zremig * solgoc * trb(ji,jj,jk,jpgoc)
+
+               ! Update the appropriate tracers trends
+               ! -------------------------------------
+               tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) + zorem3(ji,jj,jk)
+               tra(ji,jj,jk,jppon) = tra(ji,jj,jk,jppon) + solgoc * zopon2 
+               tra(ji,jj,jk,jppop) = tra(ji,jj,jk,jppop) + solgoc * zopop2
+               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + solgoc * zofer2
+               tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) + zopoc2
+               tra(ji,jj,jk,jpdon) = tra(ji,jj,jk,jpdon) + zopon2
+               tra(ji,jj,jk,jpdop) = tra(ji,jj,jk,jpdop) + zopop2
+               tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) + zofer2
+               tra(ji,jj,jk,jpgoc) = tra(ji,jj,jk,jpgoc) - zopoc2 - zorem3(ji,jj,jk)
+               tra(ji,jj,jk,jpgon) = tra(ji,jj,jk,jpgon) - zopon2 * (1. + solgoc)
+               tra(ji,jj,jk,jpgop) = tra(ji,jj,jk,jpgop) - zopop2 * (1. + solgoc)
+               tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) - zofer2 * (1. + solgoc)
+            END DO
+         END DO
+      END DO
+
+      IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+         WRITE(charout, FMT="('poc1')")
+         CALL prt_ctl_trc_info(charout)
+         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
+      ENDIF
+
+      totprod(:,:) = 0.
+      totthick(:,:) = 0.
+      totcons(:,:) = 0.
+      DO jk = 1, jpkm1
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               IF (tmask(ji,jj,jk) == 1.) THEN
+                  zdep = hmld(ji,jj)
+                  IF( fsdept(ji,jj,jk) <= zdep ) THEN
+                     totprod(ji,jj) = totprod(ji,jj) + prodpoc(ji,jj,jk) * fse3t(ji,jj,jk) * rday/ rfact2
+                     totthick(ji,jj) = totthick(ji,jj) + fse3t(ji,jj,jk)* tgfunc(ji,jj,jk)
+                     totcons(ji,jj) = totcons(ji,jj) - conspoc(ji,jj,jk) * fse3t(ji,jj,jk) * rday/ rfact2    &
+                     &                / ( trb(ji,jj,jk,jppoc) + rtrn )
+                  ENDIF
+               ENDIF
+            END DO
+         END DO
+      END DO
+
+     DO jk = 1, jpkm1
+        DO jj = 1, jpj
+           DO ji = 1, jpi
+              IF (tmask(ji,jj,jk) == 1.) THEN
+                zdep = hmld(ji,jj)
+                alphat = 0.0
+                remint = 0.0
+                IF( fsdept(ji,jj,jk) <= zdep ) THEN
+                   DO jn = 1, jcpoc
+                      alphap(ji,jj,jk,jn) = totprod(ji,jj) * alphan(jn) / ( reminp(jn)    &
+                      &                     * totthick(ji,jj) + totcons(ji,jj) + wsbio + rtrn )
+                      alphat = alphat + alphap(ji,jj,jk,jn)
+                      remint = remint + alphap(ji,jj,jk,jn) * reminp(jn)
+                   END DO
+                   DO jn = 1, jcpoc
+                      alphap(ji,jj,jk,jn) = alphap(ji,jj,jk,jn) / ( alphat + rtrn)
+                   END DO
+                   zremipoc(ji,jj,jk) = MIN(xremipc, MAX(0., remint / ( alphat + rtrn) ))
+                ENDIF
+              ENDIF
+           END DO
+        END DO
+     END DO
+
+     DO jk = 2, jpkm1
+        DO jj = 1, jpj
+           DO ji = 1, jpi
+              IF (tmask(ji,jj,jk) == 1.) THEN
+                zdep = hmld(ji,jj)
+                IF( fsdept(ji,jj,jk) > zdep ) THEN
+                  alphat = 0.
+                  remint = 0.
+                  IF ( fsdept(ji,jj,jk-1) <= zdep ) THEN
+                    DO jn = 1, jcpoc
+                       zsizek1 = fse3t(ji,jj,jk) / 2. / (wsbio3(ji,jj,jk) + rtrn) * tgfunc(ji,jj,jk)
+                       zpoc = trb(ji,jj,jk-1,jppoc) + conspoc(ji,jj,jk) * rday / rfact2               &
+                       &   * fse3t(ji,jj,jk) / 2. / (wsbio3(ji,jj,jk) + rtrn)
+                       zpoc = max(0., zpoc)
+                       alphap(ji,jj,jk,jn) = alphap(ji,jj,jk-1,jn) + zorem3(ji,jj,jk)                 &
+                       &   * ( 1. - exp( -reminp(jn) * zsizek1 ) ) * rday / rfact2                   &
+                       &   * alphag(ji,jj,jk,jn) / reminp(jn) / tgfunc(ji,jj,jk)
+                       alphat = alphat + alphap(ji,jj,jk,jn)
+                       remint = remint + alphap(ji,jj,jk,jn) * reminp(jn)
+                    END DO
+                  ELSE
+                    DO jn = 1, jcpoc
+                       zsizek  = fse3t(ji,jj,jk-1) / 2. / (wsbio3(ji,jj,jk-1) + rtrn) * tgfunc(ji,jj,jk-1)
+                       zsizek1 = fse3t(ji,jj,jk) / 2. / (wsbio3(ji,jj,jk) + rtrn) * tgfunc(ji,jj,jk)
+                       zpoc = trb(ji,jj,jk-1,jppoc) + conspoc(ji,jj,jk-1) * rday / rfact2               &
+                       &   * fse3t(ji,jj,jk-1) / 2. / (wsbio3(ji,jj,jk-1) + rtrn) + conspoc(ji,jj,jk)   &
+                       &   * rday / rfact2 * fse3t(ji,jj,jk) / 2. / (wsbio3(ji,jj,jk) + rtrn)
+                       zpoc = max(0., zpoc)
+                       alphap(ji,jj,jk,jn) = alphap(ji,jj,jk-1,jn) * exp( -reminp(jn)             &
+                       &   * ( zsizek + zsizek1 ) ) * zpoc + ( prodpoc(ji,jj,jk-1)  &
+                       &   / tgfunc(ji,jj,jk-1) * ( 1. - exp( -reminp(jn) * zsizek ) )              &
+                       &   * exp( -reminp(jn) * zsizek1 ) + prodpoc(ji,jj,jk) / tgfunc(ji,jj,jk)    &
+                       &   * ( 1. - exp( -reminp(jn) * zsizek1 ) ) ) * rday / rfact2 * alphan(jn)  &
+                       &   / reminp(jn)
+                       alphap(ji,jj,jk,jn) = alphap(ji,jj,jk,jn) + zorem3(ji,jj,jk-1)              &
+                       &  * alphag(ji,jj,jk-1,jn) / tgfunc(ji,jj,jk-1) * rday / rfact2 * ( 1.       &
+                       &  - exp( -reminp(jn) * zsizek ) ) * exp( -reminp(jn) * zsizek1 )                  &
+                       &  + zorem3(ji,jj,jk) * ( 1. - exp( -reminp(jn) * zsizek1 ) ) * rday         &
+                       &  / rfact2 * alphag(ji,jj,jk,jn) / reminp(jn) / tgfunc(ji,jj,jk)
+                       alphat = alphat + alphap(ji,jj,jk,jn)
+                       remint = remint + alphap(ji,jj,jk,jn) * reminp(jn)
+                    END DO
+                  ENDIF
+                  DO jn = 1, jcpoc
+                     alphap(ji,jj,jk,jn) = alphap(ji,jj,jk,jn) / ( alphat + rtrn)
+                  END DO
+                  zremipoc(ji,jj,jk) = MIN(xremipc, MAX(0., remint / ( alphat + rtrn) ))
+                ENDIF
+              ENDIF
+            END DO
+         END DO
+      END DO
+#endif
+
+      DO jk = 1, jpkm1
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zstep   = xstep
+# if defined key_degrad
+               zstep = zstep * facvol(ji,jj,jk)
+# endif
+               ! POC disaggregation by turbulence and bacterial activity. 
+               ! --------------------------------------------------------
+               zremip = zremipoc(ji,jj,jk) * zstep * tgfunc(ji,jj,jk)
+
+               orem(ji,jj,jk)  = zremip * trb(ji,jj,jk,jppoc)
+               zopon  = xremipn / xremipc * zremip * trb(ji,jj,jk,jppon)
+               zopop  = xremipp / xremipc * zremip * trb(ji,jj,jk,jppop)
+               zofer  = xremipn / xremipc * zremip * trb(ji,jj,jk,jpsfe)
+#if defined key_kriest
+               zopoc2 = xremipc * zremip * trb(ji,jj,jk,jpnum)
+#endif
+
+               ! Update the appropriate tracers trends
+               ! -------------------------------------
+               tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) - orem(ji,jj,jk)
+               tra(ji,jj,jk,jppon) = tra(ji,jj,jk,jppon) - zopon
+               tra(ji,jj,jk,jppop) = tra(ji,jj,jk,jppop) - zopop
+               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) - zofer
+               tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) + orem(ji,jj,jk)
+               tra(ji,jj,jk,jpdon) = tra(ji,jj,jk,jpdon) + zopon 
+               tra(ji,jj,jk,jpdop) = tra(ji,jj,jk,jpdop) + zopop 
+               tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) + zofer 
+#if defined key_kriest
+               tra(ji,jj,jk,jpnum) = tra(ji,jj,jk,jpnum) - zopoc2
+#endif
+            END DO
+         END DO
+      END DO
+
+      IF( ln_diatrc .AND. lk_iomput .AND. knt == nrdttrc ) THEN
+          zrfact2 = 1.e3 * rfact2r
+          CALL iom_put( "REMINP" , zremipoc(:,:,:) * tmask(:,:,:) )  ! Remineralisation rate
+          CALL iom_put( "REMING" , zremigoc(:,:,:) * tmask(:,:,:) )  ! Remineralisation rate
+      ENDIF
+      !
+      IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+        WRITE(charout, FMT="('poc1')")
+        CALL prt_ctl_trc_info(charout)
+        CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
+      ENDIF
+      !
+      CALL wrk_dealloc( jpi, jpj, jpk, zwork1 )
+      CALL wrk_dealloc( jpi, jpj,      totprod, totthick, totcons )
+      CALL wrk_dealloc( jpi, jpj, jpk, zremipoc, zremigoc, zorem3 )
+      DEALLOCATE( alphag )
+      !
+      IF( nn_timing == 1 )  CALL timing_stop('p5z_poc')
+      !
+   END SUBROUTINE p5z_poc
+
+
+   SUBROUTINE p5z_poc_init
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE p5z_poc_init  ***
+      !!
+      !! ** Purpose :   Initialization of remineralization parameters
+      !!
+      !! ** Method  :   Read the nampisrem namelist and check the parameters
+      !!      called at the first timestep
+      !!
+      !! ** input   :   Namelist nampisrem
+      !!
+      !!----------------------------------------------------------------------
+      INTEGER :: jn
+      REAL(wp) :: remindelta, reminup, remindown
+      NAMELIST/nampispoc/ xremipc, xremipn, xremipp, jcpoc
+      INTEGER :: ios                 ! Local integer output status for namelist read
+
+      REWIND( numnatp_ref )              ! Namelist nampispoc in reference namelist : Pisces remineralization
+      READ  ( numnatp_ref, nampispoc, IOSTAT = ios, ERR = 901)
+901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampispoc in reference namelist', lwp )
+
+      REWIND( numnatp_cfg )              ! Namelist nampispoc in configuration namelist : Pisces remineralization
+      READ  ( numnatp_cfg, nampispoc, IOSTAT = ios, ERR = 902 )
+902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampispoc in configuration namelist', lwp )
+      IF(lwm) WRITE ( numonp, nampispoc )
+
+      IF(lwp) THEN                         ! control print
+         WRITE(numout,*) ' '
+         WRITE(numout,*) ' Namelist parameters for remineralization, nampispoc'
+         WRITE(numout,*) ' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
+         WRITE(numout,*) '    remineralisation rate of POC              xremipc   =', xremipc
+         WRITE(numout,*) '    remineralisation rate of PON              xremipn   =', xremipn
+         WRITE(numout,*) '    remineralisation rate of POP              xremipp   =', xremipp
+         WRITE(numout,*) '    Number of lability classes for POC        jcpoc     =', jcpoc
+      ENDIF
+      !
+      !
+      ! Discretization along the lability space
+      ! ---------------------------------------
+      !
+      ALLOCATE( alphan(jcpoc), reminp(jcpoc) )
+      ALLOCATE( alphap(jpi,jpj,jpk,jcpoc) )
+      !
+      IF (jcpoc > 1) THEN
+         remindelta = log(4. * 1000. ) / float(jcpoc-1)
+         reminup = xremipc/400. * exp(remindelta)
+         alphan(1) = 1. - exp(-reminup/xremipc)
+         reminp(1) = xremipc - reminup * exp(-reminup/xremipc) / alphan(1)
+         DO jn = 2, jcpoc-1
+            reminup = xremipc/400. * exp(float(jn) * remindelta)
+            remindown = xremipc / 400. * exp(float(jn-1) * remindelta)
+            alphan(jn) = exp(-remindown /xremipc) - exp(-reminup/xremipc)
+            reminp(jn) = xremipc + (remindown * exp(-remindown /xremipc)    &
+            &            - reminup * exp(-reminup/xremipc) ) / alphan(jn)
+         END DO
+         remindown = xremipc/400. * exp(float(jcpoc-1) * remindelta)
+         alphan(jcpoc) = exp(-remindown /xremipc)
+         reminp(jcpoc) = xremipc + remindown
+      ELSE
+         alphan(jcpoc) = 1.
+         reminp(jcpoc) = xremipc
+      ENDIF
+
+      DO jn = 1, jcpoc
+         alphap(:,:,:,jn) = alphan(jn)
+      END DO
+
+   END SUBROUTINE p5z_poc_init
+
+#else
+   !!======================================================================
+   !!  Dummy module :                                   No PISCES bio-model
+   !!======================================================================
+CONTAINS
+   SUBROUTINE p5z_poc                    ! Empty routine
+   END SUBROUTINE p5z_poc
+#endif 
+
+   !!======================================================================
+END MODULE p5zpoc
